#include "fitline.h"

//
// warning message with one string
//
void warn(cstring p)
{
  cerr << "\n    uh-oh:\n    "
       << p << "\n\n";
}
//
// error message with one string
//
void err(cstring p)
{
    cerr << "\n   uh-oh:\n   "
         << p
         << "\n   bye...\n\n";
    exit(1);
}

//
// error message with two strings
//
void err(cstring p1, cstring p2)
{
    cerr << "\n   uh-oh:\n   "
         << p1
         << p2
         << "\n   bye...\n\n";
    exit(1);
}

//
// error message with three strings
//
void err(cstring p1, cstring p2, cstring p3)
{
    cerr << "\n   uh-oh:\n   "
         << p1
         << p2
         << p3
         << "\n   bye...\n\n";
    exit(1);
}

//
// error message with string followed by integer
//
void err(cstring p, int n)
{
    cerr << "\n   uh-oh:\n   "
         << p
         << n
         << "\n   bye...\n\n";
    exit(1);
}

//
// error message with string, integer, string
//
void err(cstring p1, int n, cstring p2)
{
    cerr << "\n   uh-oh:\n   "
         << p1
         << n
         << p2
         << "\n   bye...\n\n";
    exit(1);
}

//
// error message with string, integer, string, integer
//
void err(cstring p1, int n1, cstring p2, int n2)
{
    cerr << "\n   uh-oh:\n   "
         << p1
         << n1
         << p2
                 << n2
         << "\n   bye...\n\n";
    exit(1);
}

//
// error message with string, double, string
//
void err(cstring p1, dbl x, cstring p2)
{
    cerr << "\n   uh-oh:\n   "
         << p1
         << x
         << p2
         << "\n   bye...\n\n";
    exit(1);
}

//
// error message with string, string, string, int
//
void err(cstring p1, cstring p2, cstring p3, int n)
{
    cerr << "\n   uh-oh:\n   "
         << p1
         << p2
         << p3
         << n
         << "\n   bye...\n\n";
    exit(1);
}

//
// error message with string, double, string, double, string
//
void err(cstring p1, dbl x, cstring p2, dbl y, cstring p3)
{
    cerr << "\n   uh-oh:\n   "
         << p1
         << x
         << p2
         << y
         << p3
         << "\n   bye...\n\n";
    exit(1);
}

void error_exit_cannot_get_here(cstring fname, cint line_no)
{
  cout << "---\n"
          "PROGRAMMER ERROR: Cannot get here:\n"
          "\n"
          "  filename = " << fname   << "\n"
          "    line # = " << line_no << "\n"
          "\n"
          "Bye!\n"
          "\n";
  exit(1);
}
